<!---
In all cases, onRequestStart fires, then the fuseaction requested via the
query string/form post, then onRequestEnd.  All execute within the same
variables scope.

Both the include() and do() UDFs accept a second parameter that is a
content variable name that the output of the include/do will be placed
into.  This makes it very easy to create composite layouts in a
view-agnostic way.

There is also a location() UDF that wraps the CFLOCATION tag with
addtoken="false".

If you want to write your CFCASE bodies in CFSCRIPT, you will need to
realias the 'do' UDF to something else (perhaps 'do_') because 'do' is a
reserved word in CFSCRIPT.  Placing a line such as this in onRequestStart
will do it:

		<cfset do_ = do />
--->
<cfswitch expression="#attributes.currentFuseaction#">

	<!---
	Event Fuseactions
	--->

	<cfcase value="onRequestStart">
		<cfset DEFAULT_NAME = "World" />
		<cfset isIPhone = cgi.user_agent CONTAINS "iphone" />
	</cfcase>

	<cfcase value="onRequestEnd">
	</cfcase>

	<!---
	Normal Fuseactions
	--->

	<cfcase value="home,__default_fuseaction__">
		<cfparam name="attributes.name" default="#DEFAULT_NAME#" />
		<cfset xfa.submit = "home" />
		<cfset wasNameProvided = len(trim(attributes.name)) GT 0 AND attributes.name NEQ DEFAULT_NAME />
		<cfset include("dsp_home", "bodyContent") />
		<cfset include("frm_greeting", "bodyContent") />
		<cfset do("lay_default") />
	</cfcase>

	<!---
	Internal Fuseactions
	--->
	
	<cfcase value="lay_default">
		<cfparam name="pageTitle" default="FB3Lite Demo App" />
		<cfset include("lay_default") />
	</cfcase>

	<cfdefaultcase>
		<cfthrow type="InvalidFuseactionException"
			message="The fuseaction '#attributes.currentFuseaction#' is not recognized" />
	</cfdefaultcase>

</cfswitch>